﻿/**
* Countdown Timer - Flabell.com Product, June 2009
* @author Vuzum Media, LLC.
* http://www.vuzum.com
* email: office@vuzum.com
*/

package com.vuzum 
{
	import flash.net.URLRequest;	
	import flash.events.Event;	
	import flash.net.URLLoader;	
	import flash.display.MovieClip;
	import com.vuzum.utils.*;

	import flash.events.MouseEvent;
	import com.vuzum.timer.*;
	

	public class Main extends MovieClip 
	{
		// STATIC VARS
		private static var instance : Main;
		
		//COMPONENTS INSIDE
		private var componentWidth : Number;
		private var componentHeight : Number;
		
		public var mcTimer : Timer;
		
		private var defaultPathTo : String = "timer/";
		private var defaultXMLPath : String = "xml/settings.xml";
		
		public var pathTo : String = "";
		public var xmlPath : String;
		public var swfPath : String;
		
		//flashvars
		public var tempFlashVar : *;
		
		public var product_width : Number;
		public var product_height : Number;
		
		//XML settings
		private var settingsXML : XML;
		private var xmlObject : XML;
		private var xmlLoader : URLLoader;
		private var currPressedItem : MovieClip;
		
		//settings
		private var distanceBetweenItems : Number;
		private var timeLeft : Number;
		private var redirectURL : String;
		private var singleArray : Object;
		private var multipleArray : Object;
		public var colorsArray : Object;
		public var expArray : Object;
		private var expirationTime : Number;

		public static function getInstance() : Main
		{
			if (instance == null) 
			{
				new Main();
			}
			
			return instance;
		}

		/**
		 * Constructor
		 */
		 
		public function Main() 
		{
			instance = this;
			
			// Prototypes			
			new Prototypes();
			
			init();
		}
		
		
		public function init() : void
		{
			stage.align = "TL";
			stage.scaleMode = "noScale";
			
			/*
			 * READ THE FLASH VARS
			 */ 
			 
			// STAGE WIDTH flash var
			tempFlashVar = stage.loaderInfo.parameters.componentWidth; 
			if(tempFlashVar != null && tempFlashVar != "") componentWidth = Number(tempFlashVar);
			
			// STAGE HEIGHT flash var
			tempFlashVar = stage.loaderInfo.parameters.componentHeight; 
			if(tempFlashVar != null && tempFlashVar != "") componentHeight = Number(tempFlashVar);				
			 
			// TIME LEFT flash var
			tempFlashVar = stage.loaderInfo.parameters.timeLeft; 
			if(tempFlashVar != null && tempFlashVar != "") timeLeft = Number(tempFlashVar);
			// pass a random number for testing inside the FLA
			else timeLeft = 259200000;
			
			// TIME LEFT flash var
			tempFlashVar = stage.loaderInfo.parameters.redirect; 
			if(tempFlashVar != null && tempFlashVar != "") redirectURL = tempFlashVar;
			
			 
			 tempFlashVar = stage.loaderInfo.parameters.pathToFiles;
			
			if(tempFlashVar != "" && tempFlashVar != null )
			{
				pathTo = tempFlashVar;
			}
			// default value for FLASH IDE
			else 
			{
				pathTo = defaultPathTo;
			}
			
			
			
			// XML PATH
			tempFlashVar = stage.loaderInfo.parameters.xmlPath;
			
			if(tempFlashVar != "" && tempFlashVar != null )
			{
				xmlPath = pathTo + tempFlashVar;
			}
			// default value for FLASH IDE
			else 
			{
				xmlPath = pathTo + defaultXMLPath;
			}
			
			/*
			 * LOAD XML and then START THE APPLICATION
			 */
			 
			loadXML(xmlPath);
		}
		
		
		/**
		 * load settings xml file
		 */
		 
		private function loadXML(pXMLPath : String) : void
		{
			settingsXML = new XML();
			settingsXML.ignoreWhitespace = true;
			xmlLoader = new URLLoader(new URLRequest(pXMLPath));
			xmlLoader.addEventListener(Event.COMPLETE, parseSettingsXML);
		}
		
		
		private function parseSettingsXML(e : Event) : void
		{
		   xmlObject = new XML(e.target.data);	  
		   	
		   var product_width : *;
		   var product_height : *;
		   	
		   	
			// read the dimensions of the swf from XML
			if(isNaN(componentWidth))
			{	
				product_width = xmlObject.product.attribute("width").toString();
				
				if(product_width != "" && !isNaN(product_width)) 
					componentWidth = Number(product_width);
				else 
					componentWidth = stage.stageWidth;
			}
			
			//trace("componentWidth " + componentWidth);
			
			
			
			if(isNaN(componentHeight))
			{
				product_height = xmlObject.product.attribute("height").toString();
				
				if(product_height != "" && !isNaN(product_height)) 
					componentHeight = Number(product_height);
				else 
					componentHeight = stage.stageHeight;
			}
			
			//trace("componentHeight " + componentHeight);	
			
			
			colorsArray = new Object();
			expArray = new Object();
			singleArray = new Object();
			multipleArray = new Object();
			
			colorsArray = {
				bg_color  : xmlObject.item.attribute("bg_color").toString(),
				number_color  : xmlObject.item.attribute("number_color").toString(),
				date_color  : xmlObject.item.attribute("date_color").toString()
			};
			
			//for (var item in colorsArray) { trace(item); trace(colorsArray[item]);}
			
			distanceBetweenItems = Number(xmlObject.item.attribute("distance"));
			expirationTime = Number(xmlObject.item.attribute("expirationTime"));
			
			
			expArray = {
				bg_color  : xmlObject.expiration.attribute("bg_color").toString(),
				number_color  : xmlObject.expiration.attribute("number_color").toString(),
				date_color  : xmlObject.expiration.attribute("date_color").toString()
			};
			
			singleArray = {
				day  : xmlObject.day.attribute("single").toString(),
				hour  : xmlObject.hour.attribute("single").toString(),
				minute  : xmlObject.minute.attribute("single").toString(),
				second  : xmlObject.second.attribute("single").toString()
			};
			
			multipleArray = {
				day  : xmlObject.day.attribute("multiple").toString(),
				hour  : xmlObject.hour.attribute("multiple").toString(),
				minute  : xmlObject.minute.attribute("multiple").toString(),
				second  : xmlObject.second.attribute("multiple").toString()
			};

			
			// init
			mcTimer.init(timeLeft, redirectURL, componentWidth, componentHeight, colorsArray, expArray, singleArray, multipleArray, distanceBetweenItems, expirationTime);
		}
		
		
		/************************************************************
		 *
		 *					EVENT HANDLERS
		 * 
		 *************************************************************/				

		/**
		 * OVER EVENT HANDLER
		 */
		public function overHandler(event : MouseEvent) : void
		{
			//var mc : Object = event.currentTarget;	
		}

		/**
		 * ENTER FRAME EVENT HANDLER
		 */
		public function enterFrameHandler(event : Event) : void
		{
		}

		/**
		 * OUT HANDLER
		 */
		public function outHandler(event : MouseEvent) : void
		{
			//var mc : Object = event.currentTarget;
		}

		/**
		 * PRESS EVENT HANDLER
		 */
		public function pressHandler(event : MouseEvent) : void
		{
			var mc : MovieClip = MovieClip(event.currentTarget); 
			//trace("Event.target press..." + event.target);
			
			// set pressed the new item
			this.currPressedItem = mc;
		
			// add the release event on stage
			this.stage.addEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			this.stage.addEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE OUTSIDE EVENT HANDLER
		 */
		public function releaseOutsideHandler(e : Event) : void 
		{
			this.stage.removeEventListener(MouseEvent.MOUSE_UP, releaseOutsideHandler);
			this.stage.removeEventListener(Event.MOUSE_LEAVE, releaseOutsideHandler);
		}

		/**
		 * RELEASE event handler 
		 */
		public function releaseHandler(event : MouseEvent) : void
		{
			var mc : Object = event.currentTarget; 
			
			// call the specific function
			if(mc == currPressedItem) releaseFunction(mc);
		}

		/**
		 * RELEASE FUNCTION 
		 */
		public function releaseFunction(mc : Object) : void
		{
			switch(mc)
			{
			}
		}
		
		
		
	}
	
}
