﻿/**
* Timer - Flabell.com Product, June 2009
* @author Vuzum Media, LLC.
* http://www.vuzum.com
* email: office@vuzum.com
*/

package com.vuzum.timer 
{
	import flash.display.MovieClip;

	import com.vuzum.utils.*;
	import flash.utils.*;

	import caurina.transitions.*;
	import caurina.transitions.properties.*;

	import com.zorked.URLNavigator;	

	public class Timer extends MovieClip 
	{
		// STATIC VARS
		private static var instance : Timer;
		
		// COMPONENTS INSIDE
		public var mcBack : MovieClip;
		public var mcAllItems : MovieClip;
		
	    //colors
		private var colorsArray : Object = new Object();
		private var expArray : Object = new Object();
		private var singleArray : Object = new Object();
		private var multipleArray : Object = new Object();
		
		public var colorChanged : Boolean = false;
		
		public var expirationSound : TimerSound = new TimerSound();

		//component dimensions
        private var componentW : Number;
		private var componentH : Number;
		private var distanceBetween : Number;
		private var redirectURL : String = "";
		private var timeLeft : Number;
		private var oneSecond : Number = 1000;
		
		private var isMute : Boolean = false;
		private var lastMinutesNumber : Number;
		private var updateInterval : Number;
		

		public static function getInstance() : Timer
		{
			if (instance == null) 
			{
				new Timer();
			}
			
			return instance;
		}

		/**
		 * Player constructor
		 */
		public function Timer() 
		{
			instance = this;
			
			ColorShortcuts.init();
			TextShortcuts.init();
			
			new Prototypes();
			
			mcAllItems.visible = false;
			mcAllItems.mcItem.visible = false;
		}

		public function init(time : Number, redirect : String, componentWidth : Number , componentHeight : Number, colors : Object, exp : Object, single : Object, multiple : Object, dist : Number, expirationTime : Number) : void
		{
			timeLeft = time;
			
			redirectURL = redirect;
			
			componentW = componentWidth;
			componentH = componentHeight;
			
			colorsArray = colors;
			expArray = exp;
			singleArray = single;
			multipleArray = multiple;
			
			distanceBetween = dist;
			lastMinutesNumber = expirationTime;
			
			createItems();
		}
		
		public function playSound(str : *) : void
		{
			if(!isMute) this[str].play();
		}
		
		public function createItems() : void
		{
			for(var i : Number = 0; i < 4; i++)
			{
				mcAllItems[i]  = new mcCalItem();
				
				var mc : MovieClip = MovieClip(mcAllItems.addChild(mcAllItems[i]));
				mc.index = i;
				
				if(colorsArray.bg_color != "" && colorsArray.bg_color != null) mc.mcBack.setColor(colorsArray.bg_color);
				if(colorsArray.date_color != "" && colorsArray.date_color != null) mc.mcName.setColor(colorsArray.date_color);
				if(colorsArray.number_color != "" && colorsArray.number_color != null) mc.mcNumber.setColor(colorsArray.number_color);
				
				// position
				mc.x = mcAllItems.mcItem.x + i * (mcAllItems.mcItem.width + distanceBetween);
			}
			
			mcAllItems.mcDays = mcAllItems[0];
			mcAllItems.mcHours = mcAllItems[1];
			mcAllItems.mcMinutes = mcAllItems[2];
			mcAllItems.mcSeconds = mcAllItems[3];
			
			mcAllItems.centrateOn(componentW, -1);
			mcAllItems.visible = true;
			
			updateTime();
			updateInterval = setInterval(updateTime, oneSecond);
		}
		
		function remainingTime(difference : Number) : Object
		{
		   var retObj : Object = new Object();
		   retObj.time = difference;
		   
		   retObj.days = Math.floor(difference/(86400*oneSecond));
		   retObj.hours = Math.floor((difference-(retObj.days*86400*oneSecond))/(3600*oneSecond));
		   retObj.minutes = Math.floor((difference-(retObj.days*86400*oneSecond) - (retObj.hours*3600*oneSecond))/(60*oneSecond));
		   retObj.seconds = Math.floor((difference-(retObj.days*86400*oneSecond) - (retObj.hours*3600*oneSecond) - (retObj.minutes*60*oneSecond))/(oneSecond));
		  
		   timeLeft -= oneSecond;
		   return retObj;
		}

		public function updateTime():void 
		{
			var diff : * = remainingTime(timeLeft);
			
			// when the time will expire
			if(timeLeft < (oneSecond*60) * lastMinutesNumber)
			{
				if(colorChanged == false)
				{
					colorChanged = true;
					
					for(var i : Number = 0; i < 4; i++)
					{
						if(expArray.bg_color != "" && expArray.bg_color != null) Tweener.addTween(mcAllItems[i].mcBack, {_color : expArray.bg_color, time : 1, transition : "easeOutExpo"});
						if(expArray.date_color != "" && expArray.date_color != null) Tweener.addTween(mcAllItems[i].mcName, {_color : expArray.date_color, time : 1, transition : "easeOutExpo"});
						if(expArray.number_color != "" && expArray.number_color != null) Tweener.addTween(mcAllItems[i].mcNumber, {_color : expArray.number_color, time : 1, transition : "easeOutExpo"});
					}
				}
				
				if(timeLeft >= 0)
					playSound("expirationSound");
			}
			
			
			if(diff.days == 1)
				mcAllItems.mcDays.mcName.txt.initText(singleArray.day, true);
			else
				mcAllItems.mcDays.mcName.txt.initText(multipleArray.day, true);
			
			if(diff.days < 10)
				mcAllItems.mcDays.mcNumber.txt.initText("0" + diff.days, true);
			else
				mcAllItems.mcDays.mcNumber.txt.initText(diff.days, true);
					
			mcAllItems.mcDays.mcName.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			mcAllItems.mcDays.mcNumber.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			

			
			if(diff.hours == 1)
				mcAllItems.mcHours.mcName.txt.initText(singleArray.hour, true);
			else
				mcAllItems.mcHours.mcName.txt.initText(multipleArray.hour, true);
			
			if(diff.hours < 10)
				mcAllItems.mcHours.mcNumber.txt.initText("0" + diff.hours, true);
			else
				mcAllItems.mcHours.mcNumber.txt.initText(diff.hours, true);
			
			mcAllItems.mcHours.mcName.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			mcAllItems.mcHours.mcNumber.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			
			
			
			
			if(diff.minutes == 1)
				mcAllItems.mcMinutes.mcName.txt.initText(singleArray.minute, true);
			else
				mcAllItems.mcMinutes.mcName.txt.initText(multipleArray.minute, true);
				
			if(diff.minutes < 10)
				mcAllItems.mcMinutes.mcNumber.txt.initText("0" + diff.minutes, true);
			else
				mcAllItems.mcMinutes.mcNumber.txt.initText(diff.minutes, true);
				
			mcAllItems.mcMinutes.mcName.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			mcAllItems.mcMinutes.mcNumber.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			
			
				
			if(diff.seconds == 1)
				mcAllItems.mcSeconds.mcName.txt.initText(singleArray.second, true);
			else
				mcAllItems.mcSeconds.mcName.txt.initText(multipleArray.second, true);
			
			if(diff.seconds < 10)
				mcAllItems.mcSeconds.mcNumber.txt.initText("0" + diff.seconds, true);
			else
				mcAllItems.mcSeconds.mcNumber.txt.initText(diff.seconds, true);
			
			mcAllItems.mcSeconds.mcName.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			mcAllItems.mcSeconds.mcNumber.centrateOn(mcAllItems.mcItem.mcBack.width, -1);
			
			
			
			
			if(timeLeft <= 0)
			{
				clearInterval(updateInterval);
				
				Tweener.addTween(this, {alpha : 0, time : .5, transition : "easeOutExpo", onComplete : function() : void 
				{
					refreshPage();
				}});
			}
		}
		
		
		public function refreshPage():void
		{
			if(redirectURL != "" && redirectURL != null)
			{
				URLNavigator.ChangePage(redirectURL, "_self");
			}
			
			mcAllItems.mcDays.mcNumber.txt.initText("00");
			mcAllItems.mcHours.mcNumber.txt.initText("00");
			mcAllItems.mcMinutes.mcNumber.txt.initText("00");
			mcAllItems.mcSeconds.mcNumber.txt.initText("00");
		}
	
	}
}
